=== package/debian/changelog ===
magnum (2020.06) unstable; urgency=low

  * Version 2020.06

 -- Vladimír Vondruš <mosra@centrum.cz>  Fri, 26 Jun 2020 20:54:25 +0200

magnum (2019.10) unstable; urgency=low

  * Version 2019.10

 -- Vladimír Vondruš <mosra@centrum.cz>  Thu, 24 Oct 2019 13:13:50 +0200

magnum (2019.01) unstable; urgency=low

  * Version 2019.01

 -- Vladimír Vondruš <mosra@centrum.cz>  Mon, 04 Feb 2019 18:05:31 +0100

magnum (2018.10) unstable; urgency=low

  * Version 2018.10

 -- Vladimír Vondruš <mosra@centrum.cz>  Wed, 24 Oct 2018 15:49:30 +0200

magnum (2018.04) unstable; urgency=low

  * Version 2018.04

 -- Vladimír Vondruš <mosra@centrum.cz>  Tue, 01 May 2018 23:45:15 +0200

magnum (2018.02) unstable; urgency=low

  * Version 2018.02

 -- Vladimír Vondruš <mosra@centrum.cz>  Fri, 16 Feb 2018 00:21:48 +0100

magnum (2015.05) unstable; urgency=low

  * Version 2015.05

 -- Vladimír Vondruš <mosra@centrum.cz>  Sat, 09 May 2015 11:43:43 +0200

magnum (2014.06) unstable; urgency=low

  * Version 2014.06

 -- Vladimír Vondruš <mosra@centrum.cz>  Mon, 30 Jun 2014 01:21:04 +0200

magnum (2014.01) unstable; urgency=low

  * Version 2014.01

 -- Vladimír Vondruš <mosra@centrum.cz>  Fri, 31 Jan 2014 12:20:58 +0100
